// Function to play success audio
function playSuccessAudio() {
    $(".my_audio").trigger('play');
}


// Sample product data (replace it with your actual product data)



  // Function to update the product listing table when there are no products
  function updateProductListingNoProduct() {
    const productTable = document.querySelector('.product__table');
    const noProductRow = document.querySelector('.no-product-row');

    if (products.length === 0) {
      // Show the "No products available" row
      noProductRow.style.display = 'table-row';
    } else {
      // Hide the "No products available" row
      noProductRow.style.display = 'none';
    }
  }

 // Function to handle product selection
function selectProduct(product) {
    try {
      console.log(product.code);
    // Highlight the selected row (you can add your own styling)
    const selectedRow = document.querySelector('.selected');
    if (selectedRow) {
        selectedRow.classList.remove('selected');
    }
    
    // Find the row in the cart table that corresponds to the selected product
    const cartRows = document.querySelectorAll('.cart__product table tbody tr');
    const selectedCartRow = Array.from(cartRows).find(row => row.cells[0].textContent === product.code);
  

    console.log(selectedCartRow);
    if (selectedCartRow) {
        const cartSelectedCode = selectedCartRow.cells[0].textContent;
        const cartSelectedQuantity = selectedCartRow.cells[2].textContent;
        const cartSelectedPrice = selectedCartRow.cells[0].textContent;
        const cartSelectedTotalPrice = selectedCartRow.cells[0].textContent;
        console.log(cartSelectedCode);
        console.log(cartSelectedQuantity);
        // Update the quantity in the selected product div
        const quantityInput = document.querySelector('.selected__product .quantity');
        console.log(quantityInput);
        quantityInput.value = cartSelectedQuantity;

        // Highlight the selected row in the cart table
        selectedCartRow.classList.add('selected');
    }

    // Highlight the selected row in the product listing table
    event.currentTarget.classList.add('selected');
    } catch (error) {
      
    }
    console.log(product);
    // Update the selected product div
    updateSelectedProduct(product);
}
// Sample cart data (replace it with your actual cart data)
const cart = [];

 

  // Function to handle quantity update (add or remove)
  function updateQuantity(action) {
    const quantityInput = document.querySelector('.selected__product .quantity');
    let currentQuantity = parseInt(quantityInput.value);

    if (action === 'add') {
      currentQuantity++;
    } else if (action === 'remove' && currentQuantity > 1) {
      currentQuantity--;
    }

    quantityInput.value = currentQuantity;
    if (currentQuantity > 1){
        setTimeout(() => {
            document.getElementById('mySound').play();
          }, 3) 
    } else {
        setTimeout(() => {
            document.getElementById('myWarningSound').play();
          }, 3) 
    }
  }

  // Function to add product to cart


// Function to add product to cart
function addToCart(code, name, price) {
    quantity = document.getElementById('selectedQuantity').value
    
    console.log(quantity);
    // Check if the product is already in the cart
    const existingProduct = cart.find(product => product.code === code);
 
    if (existingProduct) {
        // If the product is already in the cart, update the quantity
        existingProduct.quantity = parseInt(quantity);
    } else {
        // If the product is not in the cart, add it to the cart
        cart.push({
            code,
            name,
            quantity: parseInt(quantity),
            price
        });
        //Todo : Add To DB Cart
        console.log(cart);
    }

    // Update cart details (total price, subtotal)
    updateCartDetails();

    // Play success audio
    playSuccessAudio();
}



// Function to update cart details
function updateCartDetails() {
    // Get cart product table body
    const cartTableBody = document.querySelector('.cart__product table tbody');

    // Clear existing rows
    cartTableBody.innerHTML = '';

    // Calculate subtotal and total price
    let subtotal = 0;

    cart.forEach(product => {
        const row = cartTableBody.insertRow();
        const totalPrice = parseFloat(product.price.replace('Sh.', '')) * product.quantity;

        // Check if the value is less than or equal to 0
        if (product.quantity <= 0 || isNaN(product.quantity)) {
          // If so, set the value to 1
          console.log(product.quantity);
          setTimeout(() => {
            document.getElementById('myWarningSound').play();
          }, 3) 
          return;
        }

        row.innerHTML = `
            <td style="display:none;">${product.code}</td>
            <td>${product.name}</td>
            <td style="display:none;">${product.quantity}</td>
            <td style="display:none;">${product.price.replace('Sh.', '')}</td>
            <td style="display:none;">${totalPrice.toFixed(2)}</td>
            <td>${product.quantity} * ${product.price.replace('Sh.', '')} = Sh.${totalPrice.toFixed(2).replace(/\d(?=(\d{3})+\.)/g,'$&,')}</td>
            <td class="delete__cart-item"><i class="fas fa-trash-alt" onclick="deleteFromCart('${product.code}')"></i></td>
        `;
        //This bellow code i added it but now i want when we selet this product to also display value of quantity in selected product as this value in the cart
        row.addEventListener('click', () => selectProduct(product));
        // Calculate subtotal
        subtotal += totalPrice;
    });

    // Display subtotal and Total in the UI (you can adjust this based on your layout)
    const total = subtotal;
    const subtotalDiv = document.querySelector('.pos__body-left-content2');
    subtotalDiv.innerHTML = `
    <div class="total__distribution">
                        <table>
                            <tr>
                                <th>Sub Total:</th>
                                <td>Sh.${subtotal.toFixed(2).replace(/\d(?=(\d{3})+\.)/g,'$&,')}</td>
                            </tr>
                            <tr>
                                <th>Item Discount:</th>
                                <td>0</td>
                            </tr>
                            <tr>
                                <th>Tax(2%):</th>
                                <td>0</td>
                            </tr>
                            <tr>
                                <th>Item Count:</th>
                                <td>${cart.length}</td>
                            </tr>
                        </table>
                    </div>
                    <div class="grand__total">
                        <h5>Grand Total:</h5>
                        <h1 class="">Sh.${total.toFixed(2).replace(/\d(?=(\d{3})+\.)/g,'$&,')}</h1>
                    </div>`;
}

// Function to delete a product from the cart
function deleteFromCart(code) {
    // Find the index of the product in the cart
    const productIndex = cart.findIndex(product => product.code === code);

    if (productIndex !== -1) {
        // Remove the product from the cart
        cart.splice(productIndex, 1);

        // Update cart details (total price, subtotal)
        updateCartDetails();

        // Play success audio
        playSuccessAudio();

        // Repopulate the cart table
        populateCartTable(cart);
    }
}


// Function to play success audio
function playSuccessAudio() {
    document.getElementById('mySound').play();
}



 // Function to update the selected product div
 function updateSelectedProduct(product) {
    console.log(product.code);
    //Check if product exist in cart using code then print its quantity
    const existingProduct = cart.find(item => item.code === product.code); 
    // Display the quantity if the product is in the cart
    const quantityInCart = existingProduct ? existingProduct.quantity : product.quantity;

    const selectedProductDiv = document.querySelector('.selected__product .product__item');

    
    
    selectedProductDiv.innerHTML = `
      <div class="product__banner">
        <a href="#" class="product__images">
          <img src="assets/img/${product.name.toLowerCase()}.jpg" alt="" class="product__img-selected default">
        <!--<img src="${product.image}" alt="" class="product__img-selected default">-->
        </a>
      </div>
      <span class="product__category">${product.name}</span>
      <div class="product__price flex">
        <span class="new__price">Price: ${product.price}</span> <br> 
      </div>
      <div class="quantity__action">
        <div class="btn__quantity-minus btn__quantity" onclick="updateQuantity('remove')">-</div>
        <input type="text" value="${quantityInCart}" id="selectedQuantity" class="quantity"> 
        <div class="btn__quantity-add btn__quantity" onclick="updateQuantity('add')">+</div>
      </div>
      <div href="#" class="action__btn cart__btn" onclick="addToCart('${product.code}', '${product.name}','${product.price}')">
        <i class="fi fi-rs-shopping-bag-add"></i> Add To Cart
      </div>
    `;
  }



/*    Handle the Scanner Input in the Select value*/
console.log("Text");
// Assuming you have an input field with the id "scannerInput"
const scannerInput = document.getElementById('scannerInput');


console.log("Test"+scannerInput.value);
/* Start Scanner Test */
// Variable to store the scanned barcode
let scannedBarcode = '';
const scannerInput_value = ''
// Add an event listener for keydown events
document.addEventListener('keydown', handleKeyDown);
// Function to handle keydown events
function handleKeyDown(event) {
    // Check if the pressed key is Enter (key code 13)
    scannerInput.value == event.keyCode;
    console.log(scannerInput.value);
    if (event.keyCode === 13) {
        // Process the scanned barcode
        console.log('Scanned Barcode:', scannedBarcode);  
        scannerInput_value = scannedBarcode;
        console.log(scannerInput.value);

    } else {
        // Append the pressed key to the scannedBarcode variable
        scannedBarcode += event.key;
    }
} 

console.log(scannedBarcode);
/* End Scanner Test */

// Add an event listener to the scanner input field
scannerInput.addEventListener('input', handleScannerInput);

// Function to handle scanner input
function handleScannerInput() {
    // Get the scanned code from the scanner input field
    const scannedCode = scannerInput.value;

    // Find the product in the products array based on the scanned code
    const scannedProduct = products.find(product => product.code === scannedCode);

    console.log(scannedProduct);

    // If the product is found, call the selectProduct function
    if (scannedProduct) {
        selectProduct(scannedProduct);
    }
 
}





handleScannerInput();

// Initial population of the product listing table
populateProductTable(products);






  
 