// Fetch data from the API
fetch('https://dummyjson.com/products/')
  .then(response => response.json())
  .then(data => {
    const products = data.products.map(product => ({
      code: product.id.toString(),
      name: product.title,
      quantity: '1', // You may adjust this based on your requirements
      price: `Sh.${product.price}`,
      image: product.images[0]
    }));

    console.log(products);
    // Call the function to populate the product table
    populateProductTable(products);
  })
  .catch(error => console.error('Error fetching data:', error));

// Function to populate product listing table
function populateProductTable(productList) {
  const productTable = document.querySelector('.product__table tbody');
  productTable.innerHTML = '';

  productList.forEach(product => {
    const row = productTable.insertRow();
    row.innerHTML = `
      <td><img src="${product.image}" alt="" class="product__img"></td>
      <td>${product.code}</td>
      <td>${product.name}</td>
      <td>${product.quantity}</td>
      <td>${product.price}</td>
    `;

    // Add click event listener to each row for product selection
    row.addEventListener('click', () => selectProduct(product));
  });

  // Update product listing for the initial state
  updateProductListingNoProduct();
}