// Function to update the time every second
function updateTime() {
    const displayTimeElement = document.getElementById('displayTime');
    const currentTime = new Date();
    const hours = currentTime.getHours();
    const minutes = currentTime.getMinutes();
    const seconds = currentTime.getSeconds();

    const formattedTime = formatTime(hours, minutes, seconds);
    displayTimeElement.textContent = formattedTime;
}

// Function to format time in 12-hour format
function formatTime(hours, minutes, seconds) {
    const meridiem = hours >= 12 ? 'pm' : 'am';
    const formattedHours = hours % 12 || 12; // Convert 0 to 12
    const formattedMinutes = padZero(minutes);
    const formattedSeconds = padZero(seconds);

    return `${formattedHours}:${formattedMinutes}:${formattedSeconds}${meridiem}`;
}

// Function to pad single-digit minutes and seconds with zero
function padZero(value) {
    return value < 10 ? '0' + value : value;
}

// Update time every second
setInterval(updateTime, 1000);
